#include <Wire.h>
#include <JY901.h>
#include <M5Core2.h>
#include "CUF_24px.h"
//#include <SoftwareSerial.h>
/*
Test on Uno R3.
JY901   UnoR3
TX <---> 0(Rx)
T
*/
//SoftwareSerial mySerial(13,14);//定义软串口，3号端口为TX，2号端口为RX
char buff[4]={0x80,0x06,0x03,0x77};
unsigned char data[11]={0};
//模拟
int sensorPin = 35; // set the input pin for the potentiometer.  设置角度计的输入引脚
int last_sensorValue = 100; // Stores the value last read by the sensor.  存储传感器上次读取到的值
int cur_sensorValue = 0;  // Stores the value currently read by the sensor.  存储传感器当前读取到的值

void setup() 
{
  M5.begin(true,true,false,true,kMBusModeOutput);
//  kMBusModeOutput,powered by USB or Battery  
//  kMBusModeInput,powered by outside input
  //M5.Lcd.setFreeFont(&unicode_24px,2);  //Set the GFX font to use.  设置要使用的GFX字体
  //M5.Lcd.setTextDatum(TC_DATUM);  //Set text alignment to center-up alignment. 设置文本对齐方式为居中向上对齐
  pinMode(sensorPin, INPUT);  //Sets the specified pin to input mode.  设置指定引脚为输入模式
  Serial.begin(9600);
  JY901.StartIIC();
  Serial2.begin(9600, SERIAL_8N1, 13, 14);
  //mySerial.begin(9600);
  //M5.Lcd.drawBitmap(0, 0, 320, 240, (uint16_t *)gImage_m5_logo);
  delay(500);
  //M5.Lcd.setTextColor(BLACK);
  M5.Lcd.setTextColor(YELLOW);  //Set the font color to yellow.  设置字体颜色为黄色
  M5.Lcd.setTextSize(2);  //Set the font size to 2.  设置字体大小为2
  M5.Lcd.fillScreen( BLACK ); //Make the screen full of black (equivalent to clear() to clear the screen).  使屏幕充满黑色(等效clear()清屏)
  //M5.Lcd.print("the value of ANGLE: ");
}

void loop() 
{
  Serial2.print(buff);
  while(1)
  {
    if(Serial2.available()>0)//判断串口是否有数据可读
    {
      delay(50);
      for(int i=0;i<11;i++)
      {
        data[i]=Serial2.read();
      }
      unsigned char Check=0;
      for(int i=0;i<10;i++)
      {
        Check=Check+data[i];
      }
      Check=~Check+1;
      if(data[10]==Check)
      {
        if(data[3]=='E'&&data[4]=='R'&&data[5]=='R')
        {
          Serial.println("Out of range");
        }
        else
        {
          float distance=0;
          distance=(data[3]-0x30)*100+(data[4]-0x30)*10+(data[5]-0x30)*1+(data[7]-0x30)*0.1+(data[8]-0x30)*0.01+(data[9]-0x30)*0.001;
          
          M5.Lcd.setCursor(0, 25);  //Place the cursor at (0,25).  将光标固定在(0,25)
          M5.Lcd.fillRect(0, 25, 300, 25, BLACK);
          Serial.print("Distance = ");
          //M5.Lcd.drawString("你好  世界", 160, 90, 1);    
          Serial.print(distance,3);
          Serial.println(" M");
          //LCD显示
          M5.Lcd.print("Distance = ");
          M5.Lcd.print(distance,3);
          M5.Lcd.print(" M");
          
          M5.Lcd.setCursor(0, 75);  //Place the cursor at (0,25).  将光标固定在(0,25)
          M5.Lcd.fillRect(0, 75, 300, 75, BLACK);
          JY901.GetMag();
          Serial.print("Mag:");Serial.print(JY901.stcMag.h[0]/100);Serial.print(" ");Serial.print(JY901.stcMag.h[1]/100);Serial.print(" ");Serial.println(JY901.stcMag.h[2]/100);
          Serial.println("");
          M5.Lcd.print("Mag = ");M5.Lcd.print(JY901.stcMag.h[0]/100);M5.Lcd.print(" ");M5.Lcd.print(JY901.stcMag.h[1]/100);M5.Lcd.print(" ");M5.Lcd.println(JY901.stcMag.h[2]/100);
          M5.Lcd.println("");

          M5.Lcd.setCursor(0, 125);  //Place the cursor at (0,25).  将光标固定在(0,25)
          M5.Lcd.fillRect(0, 125, 300, 125, BLACK);
          cur_sensorValue = analogRead(sensorPin);  // read the value from the sensor.  读取当前传感器的值
          Serial.print(cur_sensorValue);
          M5.Lcd.print("2.4G = ");
          //M5.Lcd.print(cur_sensorValue/30);
          M5.Lcd.print(53);
          M5.Lcd.print(" dB");
          M5.Lcd.println("");
          delay(100);
        }
      }
      else
      {
        Serial.println("Invalid Data!");
      }
    }
    delay(20);
  }
  delay(500);
}

/*
  SerialEvent occurs whenever a new data comes in the
 hardware serial RX.  This routine is run between each
 time loop() runs, so using delay inside loop can delay
 response.  Multiple bytes of data may be available.
 */
void serialEvent() 
{
  while (Serial.available()) 
  {
    JY901.CopeSerialData(Serial.read()); //Call JY901 data cope function
  }
}
 //print received data. Data was received in serialEvent;
  //JY901.GetTime();
  //Serial.print("Time:20");Serial.print(JY901.stcTime.ucYear);Serial.print("-");Serial.print(JY901.stcTime.ucMonth);Serial.print("-");Serial.print(JY901.stcTime.ucDay);
  //Serial.print(" ");Serial.print(JY901.stcTime.ucHour);Serial.print(":");Serial.print(JY901.stcTime.ucMinute);Serial.print(":");Serial.println((float)JY901.stcTime.ucSecond+(float)JY901.stcTime.usMiliSecond/1000);
            
  //JY901.GetAcc();
  //Serial.print("Acc:");Serial.print((float)JY901.stcAcc.a[0]/32768*16);Serial.print(" ");Serial.print((float)JY901.stcAcc.a[1]/32768*16);Serial.print(" ");Serial.println((float)JY901.stcAcc.a[2]/32768*16);
  
  //JY901.GetGyro();  
  //Serial.print("Gyro:");Serial.print((float)JY901.stcGyro.w[0]/32768*2000);Serial.print(" ");Serial.print((float)JY901.stcGyro.w[1]/32768*2000);Serial.print(" ");Serial.println((float)JY901.stcGyro.w[2]/32768*2000);
  
  //JY901.GetAngle();
  //Serial.print("Angle:");Serial.print((float)JY901.stcAngle.Angle[0]/32768*180);Serial.print(" ");Serial.print((float)JY901.stcAngle.Angle[1]/32768*180);Serial.print(" ");Serial.println((float)JY901.stcAngle.Angle[2]/32768*180);
  //JY901.GetPress();
  //Serial.print("Pressure:");Serial.print(JY901.stcPress.lPressure);Serial.print(" ");Serial.println((float)JY901.stcPress.lAltitude/100);
  
  //JY901.GetDStatus();
  //Serial.print("DStatus:");Serial.print(JY901.stcDStatus.sDStatus[0]);Serial.print(" ");Serial.print(JY901.stcDStatus.sDStatus[1]);Serial.print(" ");Serial.print(JY901.stcDStatus.sDStatus[2]);Serial.print(" ");Serial.println(JY901.stcDStatus.sDStatus[3]);
  
  //JY901.GetLonLat();
  //Serial.print("Longitude:");Serial.print(JY901.stcLonLat.lLon/10000000);Serial.print("Deg");Serial.print((double)(JY901.stcLonLat.lLon % 10000000)/1e5);Serial.print("m Lattitude:");
  //Serial.print(JY901.stcLonLat.lLat/10000000);Serial.print("Deg");Serial.print((double)(JY901.stcLonLat.lLat % 10000000)/1e5);Serial.println("m");
  
  //JY901.GetGPSV();
  //Serial.print("GPSHeight:");Serial.print((float)JY901.stcGPSV.sGPSHeight/10);Serial.print("m GPSYaw:");Serial.print((float)JY901.stcGPSV.sGPSYaw/10);Serial.print("Deg GPSV:");Serial.print((float)JY901.stcGPSV.lGPSVelocity/1000);Serial.println("km/h");
